<?php

namespace Tests\Support;

use Drp\UserManagement\Contracts\HasRoles;
use Drp\UserManagement\User;

trait InteractsWithUsers
{
    protected $adminUser;

    protected function actingAsUser()
    {
        $this->adminUser = factory(User::class)->make(['role' => 'User']);
        $this->actingAs($this->adminUser);
        return $this;
    }

    protected function actingAsAdmin()
    {
        $this->adminUser = factory(User::class)->make(['role' => 'Administrator']);
        $this->actingAs($this->adminUser);
        return $this;
    }

    protected function actingAsSuperAdmin()
    {
        $this->adminUser = factory(User::class)->make(['role' => 'Super Administrator']);
        $this->actingAs($this->adminUser);
        return $this;
    }

}
